/***************************************************************************
 *
 * Copyright (c) 2002 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * cam_macr.h - defines macros for CAM
 *
 ***************************************************************************/
#ifdef	_MMIO_
	#define	WritePortUlong(BaseAddress, Offset, Data )\
	{\
		camWriteRegDword(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortUlong(BaseAddress, Offset, Data )\
	{\
		Data = camReadRegDword(BaseAddress+Offset);\
	}

	#define	WritePortWord(BaseAddress, Offset, Data )\
	{\
		camWriteRegWord(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortWord(BaseAddress, Offset, Data )\
	{\
		Data = camReadRegWord(BaseAddress+Offset);\
	}
		
	#define	WritePortUchar(BaseAddress, Offset, Data )\
	{\
		camWriteRegByte(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortUchar(BaseAddress, Offset, Data )\
	{\
		Data = camReadRegByte(BaseAddress+Offset);\
	}

	#define WriteIndexWord(BaseAddress, Index, Data )\
	{\
		camWriteRegWord(BaseAddress+Index, Data);\
	}	

	#define ReadIndexWord(BaseAddress, Index, Data )\
	{\
		Data = camReadRegWord( BaseAddress+Index);\
	}
		
	#define WriteIndexUlong(BaseAddress, Index, Data )\
	{\
		camWriteRegDword(BaseAddress+Index, Data);\
	}	

	#define ReadIndexUlong(BaseAddress, Index, Data )\
	{\
		Data = camReadRegDword( BaseAddress+Index);\
	}	
	
#else
	#define	WritePortUlong(BaseAddress, Offset, Data )\
	{\
		camOutPortDword(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortUlong(BaseAddress, Offset, Data )\
	{\
		Data = camInPortDword(BaseAddress+Offset);\
	}	
	
	#define	WritePortWord(BaseAddress, Offset, Data )\
	{\
		camOutPortWord(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortWord(BaseAddress, Offset, Data )\
	{\
		Data = camInPortWord(BaseAddress+Offset);\
	}
	
	#define	WritePortUchar(BaseAddress, Offset, Data )\
	{\
		camOutPortByte(BaseAddress+Offset, Data);\
	}
	
	#define	ReadPortUchar(BaseAddress, Offset, Data )\
	{\
		Data = camInPortByte(BaseAddress+Offset);\
	}
	
	#define WriteIndexWord(BaseAddress, Index, Data )\
	{\
		camOutPortByte(BaseAddress+ INDEX_REGISTER_OFFSET, Index);\
		camOutPortWord(BaseAddress+ DATA_REGISTER_OFFSET, Data);\
	}

	#define ReadIndexWord(BaseAddress, Index, Data )\
	{\
		camOutPortByte(BaseAddress+ INDEX_REGISTER_OFFSET, Index);\
		Data = camInPortWord(BaseAddress+ DATA_REGISTER_OFFSET);\
	}
		
	#define WriteIndexUlong(BaseAddress, Index, Data )\
	{\
		camOutPortByte(BaseAddress+ INDEX_REGISTER_OFFSET, Index);\
		camOutPortDword(BaseAddress+ DATA_REGISTER_OFFSET, Data);\
	}

	#define ReadIndexUlong(BaseAddress, Index, Data )\
	{\
		camOutPortByte(BaseAddress+ INDEX_REGISTER_OFFSET, Index);\
		Data = camInPortDword(BaseAddress+ DATA_REGISTER_OFFSET);\
	}	
	
#endif

/*
 *  Macros for ATA module 
 */
#define GetStatus(IDEBaseAddress, Status)\
	Status = ReadIndexUchar(IDEBaseAddress, iNDEXIDEAlternateStatus);\

#define GetBaseStatus(IDEBaseAddress, Status)\
	Status = ReadIndexUchar(IDEBaseAddress, iNDEXIDEStatus);\


/*
* for Big or Little Endian platform transform
*/
#ifdef	_BIG_ENDIAN_
	#define	CamByteSwap32(x)	( ( ( x<<24 ) & 0xFF000000 ) | \
				  ( ( x<<8  ) & 0x00FF0000 ) | \
				  ( ( x>>8  ) & 0x0000FF00 ) | \
				  ( ( x>>24 ) & 0x000000FF ) );

	#define	CamByteSwap16(x)	( ( ( x<<8 ) & 0xFF00 ) | \
				  ( ( x>>8 ) & 0x00FF ) );
#else
	#define	CamByteSwap32(x)	(x)
	#define	CamByteSwap16(x)	(x)
#endif


